%if 0%{?rhel} && 0%{?rhel} <= 6
%{!?__python2: %global __python2 /usr/bin/python2}
%{!?python2_sitelib: %global python2_sitelib %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib())")}
%{!?python2_sitearch: %global python2_sitearch %(%{__python2} -c "from distutils.sysconfig import get_python_lib; print(get_python_lib(1))")}

%global python2_version 2.6
%global with_python3 0
%global pypi_name petsc4py
%else
%global with_python3 1
%global pypi_name petsc4py
%endif

%if 0%{?fedora}
%global with_python3 1
%global pypi_name petsc4py

%global with_mpich 1
%global with_openmpi 1
%endif

# No MPICH support on these arches
%if 0%{?rhel} || 0%{?rhel} < 7
%ifarch %{power64}
%global with_mpich 0
%endif
%endif
%if 0%{?rhel} || 0%{?rhel} < 7
%ifnarch %{power64}
%global with_mpich 1
%endif
%endif
%if 0%{?fedora} || 0%{?rhel} >= 7
%global with_mpich 1
%global with_openmpi 1
%endif

%global mpiarchdir -%{_arch}

%global petscver 3.8.1

# PETSc does not provide MPI builds on s390x
ExcludeArch: s390x

#Macros not used in this release
#%%global         commit          ac769fc79a91d574f53681a281d3fff816bd6961
#%%global         shortcommit     %%(c=%%{commit}; echo ${c:0:7})
#%%global         datecommit      20170629

## Make python?_shortver macros
%{!?python3_shortver: %global python3_shortver %(%{__python3} -c 'import sys; print(str(sys.version_info.major) + "." + str(sys.version_info.minor))')}

Name:           %{pypi_name}
Version:        3.8.1
#Tag not used in this release
#Release:        1.%%{datecommit}git%%{shortcommit}%%{?dist}
Release:        3%{?dist}
Summary:        Python bindings for MPI PETSc

License:        BSD
URL:            https://bitbucket.org/petsc/%{pypi_name}
Source0:        https://bitbucket.org/petsc/petsc4py/downloads/%{pypi_name}-%{version}.tar.gz

# Set directories where MPI libraries are
Patch0:         %{name}-openmpi_set_dir.patch
Patch1:         %{name}-mpich_set_dir.patch

%description
This package provides Python bindings for PETSc,
the Portable, Extensible Toolkit for Scientific Computation.

%if 0%{?with_openmpi}
%package -n     python2-%{pypi_name}-openmpi
Summary:        Python2 bindings for OpenMPI PETSc
%{?python_provide:%python_provide python2-%{pypi_name}-openmpi}

BuildRequires:  python2-devel
BuildRequires:  hdf5-openmpi-devel
BuildRequires:  scalapack-openmpi-devel
BuildRequires:  ptscotch-openmpi-devel
BuildRequires:  petsc-openmpi-devel >= %{petscver}
BuildRequires:  numpy, Cython
Requires:       petsc-openmpi%{?_isa} >= %{petscver}
Requires:       hdf5-openmpi%{?_isa}
Requires:       scalapack-openmpi%{?_isa}
Requires:       ptscotch-openmpi%{?_isa}
Requires:       openmpi%{?_isa}

%description -n python2-%{pypi_name}-openmpi
This package provides Python2 bindings for OpenMPI PETSc,
the Portable, Extensible Toolkit for Scientific Computation.

%package -n     %{pypi_name}-openmpi-devel
Summary:        %{pypi_name} devel files

%description -n %{pypi_name}-openmpi-devel
This package provides header files of Python OpenMPI PETsc.

%if 0%{?with_python3}
%package -n     python%{python3_pkgversion}-%{pypi_name}-openmpi
Summary:        Python3 bindings for OpenMPI PETSc
%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}-openmpi}

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  hdf5-openmpi-devel
BuildRequires:  scalapack-openmpi-devel
BuildRequires:  ptscotch-openmpi-devel
BuildRequires:  petsc-openmpi-devel >= %{petscver}
BuildRequires:  python%{python3_pkgversion}-numpy, python%{python3_pkgversion}-Cython
Requires:       petsc-openmpi%{?_isa} >= %{petscver}
Requires:       hdf5-openmpi%{?_isa}
Requires:       scalapack-openmpi%{?_isa}
Requires:       ptscotch-openmpi%{?_isa}
Requires:       openmpi%{?_isa}

%description -n python%{python3_pkgversion}-%{pypi_name}-openmpi
This package provides Python3 bindings for OpenMPI PETSc,
the Portable, Extensible Toolkit for Scientific Computation.
%endif
%endif

%if 0%{?with_mpich}
%package -n     python2-%{pypi_name}-mpich
Summary:        Python2 bindings for MPICH PETSc
%{?python_provide:%python_provide python2-%{pypi_name}-mpich}

BuildRequires:  python2-devel
BuildRequires:  hdf5-mpich-devel
BuildRequires:  scalapack-mpich-devel
BuildRequires:  ptscotch-mpich-devel
BuildRequires:  petsc-mpich-devel >= %{petscver}
BuildRequires:  numpy, Cython
Requires:       petsc-mpich%{?_isa} >= %{petscver}
Requires:       hdf5-mpich%{?_isa}
Requires:       scalapack-openmpi%{?_isa}
Requires:       ptscotch-mpich%{?_isa}
Requires:       mpich%{?_isa}

%description -n python2-%{pypi_name}-mpich
This package provides Python2 bindings for MPICH PETSc,
the Portable, Extensible Toolkit for Scientific Computation.

%package -n     %{pypi_name}-mpich-devel
Summary:        %{pypi_name} devel files

%description -n %{pypi_name}-mpich-devel
This package provides header files of Python MPICH PETsc.

%if 0%{?with_python3}
%package -n     python%{python3_pkgversion}-%{pypi_name}-mpich
Summary:        Python3 bindings for MPICH PETSc
%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}-mpich}

BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  hdf5-mpich-devel
BuildRequires:  scalapack-mpich-devel
BuildRequires:  ptscotch-mpich-devel
BuildRequires:  petsc-mpich-devel >= %{petscver}
BuildRequires:  python%{python3_pkgversion}-numpy, python%{python3_pkgversion}-Cython
Requires:       petsc-mpich%{?_isa} >= %{petscver}
Requires:       hdf5-mpich%{?_isa}
Requires:       scalapack-openmpi%{?_isa}
Requires:       ptscotch-mpich%{?_isa}
Requires:       mpich%{?_isa}

%description -n python%{python3_pkgversion}-%{pypi_name}-mpich
This package provides Python3 bindings for MPICH PETSc,
the Portable, Extensible Toolkit for Scientific Computation.
%endif
%endif

%prep
%setup -qc

rm -rf %{pypi_name}-%{version}/%{pypi_name}.egg-info

cp -a %{pypi_name}-%{version} %{pypi_name}-mpich
mv %{pypi_name}-%{version} %{pypi_name}-openmpi

%if 0%{?with_openmpi}
pushd %{pypi_name}-openmpi
%patch0 -p0
%if %{?__isa_bits:%{__isa_bits}}%{!?__isa_bits:32} == 64
sed -e 's|@@arch@@|%{_arch}|g' -i conf/baseconf.py
sed -e 's|@@bits@@|%{?__isa_bits}|g' -i conf/baseconf.py
sed -e 's|@@petscver@@|%{petscver}|g' -i conf/baseconf.py
%else
sed -e 's|@@arch@@|%{_arch}|g' -i conf/baseconf.py
sed -e 's|@@bits@@||g' -i conf/baseconf.py
sed -e 's|@@petscver@@|%{petscver}|g' -i conf/baseconf.py
%endif
popd
%endif

%if 0%{?with_mpich}
pushd %{pypi_name}-mpich
%patch1 -p0
%if %{?__isa_bits:%{__isa_bits}}%{!?__isa_bits:32} == 64
sed -e 's|@@arch@@|%{_arch}|g' -i conf/baseconf.py
sed -e 's|@@bits@@|%{?__isa_bits}|g' -i conf/baseconf.py
sed -e 's|@@petscver@@|%{petscver}|g' -i conf/baseconf.py
%else
sed -e 's|@@arch@@|%{_arch}|g' -i conf/baseconf.py
sed -e 's|@@bits@@||g' -i conf/baseconf.py
sed -e 's|@@petscver@@|%{petscver}|g' -i conf/baseconf.py
%endif
popd
%endif

%build
# openmpi petsc4py
%if 0%{?with_openmpi}
pushd %{pypi_name}-openmpi
%{_openmpi_load}
export PETSC_DIR=%{_prefix}
CFLAGS="%{optflags}" %{__python2} setup.py build --executable="%{__python2} -s" 
%if 0%{?with_python3}
CFLAGS="%{optflags}" %{__python3} setup.py build --executable="%{__python3} -s" 
%endif
popd
%{_openmpi_unload}
%endif

# mpich petsc4py
%if 0%{?with_mpich}
pushd %{pypi_name}-mpich
%{_mpich_load}
export PETSC_DIR=%{_prefix}
CFLAGS="%{optflags}" %{__python2} setup.py build --executable="%{__python2} -s" 
%if 0%{?with_python3}
CFLAGS="%{optflags}" %{__python3} setup.py build --executable="%{__python3} -s" 
%endif
popd
%{_mpich_unload}
%endif

%install
# openmpi petsc4py
%if 0%{?with_openmpi}
%{_openmpi_load}
pushd %{pypi_name}-openmpi
CFLAGS="%{optflags}" %{__python2} setup.py install -O1 --skip-build --root %{buildroot}

mkdir -p %{buildroot}%{_includedir}/openmpi%{mpiarchdir}
cp -a %{buildroot}%{python2_sitearch}/%{pypi_name}/include/%{pypi_name} %{buildroot}%{_includedir}/openmpi%{mpiarchdir}/
rm -rf %{buildroot}%{python2_sitearch}/%{pypi_name}/include

# Install petsc4py files into MPI directories 
mkdir -p %{buildroot}%{python2_sitearch}/openmpi
cp -a %{buildroot}%{python2_sitearch}/%{pypi_name} %{buildroot}%{python2_sitearch}/openmpi/
rm -rf %{buildroot}%{python2_sitearch}/%{pypi_name}
cp -a %{buildroot}%{python2_sitearch}/%{pypi_name}-%{version}-py%{python2_version}.egg-info %{buildroot}%{python2_sitearch}/openmpi/
rm -rf %{buildroot}%{python2_sitearch}/%{pypi_name}-%{version}-py%{python2_version}.egg-info

%if 0%{?with_python3}
CFLAGS="%{optflags}" %{__python3} setup.py install -O1 --skip-build --root %{buildroot}

# Install petsc4py files into MPI directories 
mkdir -p %{buildroot}%{python3_sitearch}/openmpi
cp -a %{buildroot}%{python3_sitearch}/%{pypi_name} %{buildroot}%{python3_sitearch}/openmpi/
rm -rf %{buildroot}%{python3_sitearch}/%{pypi_name}
cp -a %{buildroot}%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info %{buildroot}%{python3_sitearch}/openmpi/
rm -rf %{buildroot}%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info
%endif
%{_openmpi_unload}
popd
%endif

# mpich petsc4py
%if 0%{?with_mpich}
pushd %{pypi_name}-mpich
%{_mpich_load}
CFLAGS="%{optflags}" %{__python2} setup.py install -O1 --skip-build --root %{buildroot}

mkdir -p %{buildroot}%{_includedir}/mpich%{mpiarchdir}
cp -a %{buildroot}%{python2_sitearch}/%{pypi_name}/include/%{pypi_name} %{buildroot}%{_includedir}/mpich%{mpiarchdir}/
rm -rf %{buildroot}%{python2_sitearch}/%{pypi_name}/include

# Install petsc4py files into MPI directories 
mkdir -p %{buildroot}%{python2_sitearch}/mpich
cp -a %{buildroot}%{python2_sitearch}/%{pypi_name} %{buildroot}%{python2_sitearch}/mpich/
rm -rf %{buildroot}%{python2_sitearch}/%{pypi_name}
cp -a %{buildroot}%{python2_sitearch}/%{pypi_name}-%{version}-py%{python2_version}.egg-info %{buildroot}%{python2_sitearch}/mpich/
rm -rf %{buildroot}%{python2_sitearch}/%{pypi_name}-%{version}-py%{python2_version}.egg-info

%if 0%{?with_python3}
CFLAGS="%{optflags}" %{__python3} setup.py install -O1 --skip-build --root %{buildroot}

# Install petsc4py files into MPI directories 
mkdir -p %{buildroot}%{python3_sitearch}/mpich
cp -a %{buildroot}%{python3_sitearch}/%{pypi_name} %{buildroot}%{python3_sitearch}/mpich/
rm -rf %{buildroot}%{python3_sitearch}/%{pypi_name}
cp -a %{buildroot}%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info %{buildroot}%{python3_sitearch}/mpich/
rm -rf %{buildroot}%{python3_sitearch}/%{pypi_name}-%{version}-py%{python3_version}.egg-info
%endif
%{_mpich_unload}
popd
%endif

%check
# openmpi petsc4py
%if 0%{?with_openmpi}
%{_openmpi_load}
pushd %{pypi_name}-openmpi
export PYTHONPATH=$RPM_BUILD_ROOT%{python2_sitearch}/openmpi
%{__python2} setup.py test

%if 0%{?with_python3}
export PYTHONPATH=$RPM_BUILD_ROOT%{python3_sitearch}/openmpi
%{__python3} setup.py test
%endif
%{_openmpi_unload}
popd
%endif

# mpich petsc4py
%if 0%{?with_mpich}
%{_mpich_load}
pushd %{pypi_name}-mpich
export PYTHONPATH=$RPM_BUILD_ROOT%{python2_sitearch}/mpich
%{__python2} setup.py test

%if 0%{?with_python3}
export PYTHONPATH=$RPM_BUILD_ROOT%{python3_sitearch}/mpich
%{__python3} setup.py test
%endif
%{_mpich_unload}
popd
%endif

%if 0%{?with_openmpi}
%files -n python2-%{pypi_name}-openmpi
%doc %{pypi_name}-openmpi/CHANGES.* %{pypi_name}-openmpi/README.*
%license %{pypi_name}-openmpi/LICENSE.rst
%{python2_sitearch}/openmpi/%{pypi_name}/
%{python2_sitearch}/openmpi/%{pypi_name}-%{version}-py%{python2_version}.egg-info

%files -n %{pypi_name}-openmpi-devel
%{_includedir}/openmpi%{mpiarchdir}/%{pypi_name}/

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{pypi_name}-openmpi
%doc %{pypi_name}-openmpi/CHANGES.* %{pypi_name}-openmpi/README.*
%license %{pypi_name}-openmpi/LICENSE.rst
%{python3_sitearch}/openmpi/%{pypi_name}/
%{python3_sitearch}/openmpi/%{pypi_name}-%{version}-py%{python3_version}.egg-info
%endif
%endif

%if 0%{?with_mpich}
%files -n python2-%{pypi_name}-mpich
%doc %{pypi_name}-mpich/CHANGES.* %{pypi_name}-mpich/README.*
%license %{pypi_name}-mpich/LICENSE.rst
%{python2_sitearch}/mpich/%{pypi_name}/
%{python2_sitearch}/mpich/%{pypi_name}-%{version}-py%{python2_version}.egg-info

%files -n %{pypi_name}-mpich-devel
%{_includedir}/mpich%{mpiarchdir}/%{pypi_name}/

%if 0%{?with_python3}
%files -n python%{python3_pkgversion}-%{pypi_name}-mpich
%doc %{pypi_name}-mpich/CHANGES.* %{pypi_name}-mpich/README.*
%license %{pypi_name}-mpich/LICENSE.rst
%{python3_sitearch}/mpich/%{pypi_name}/
%{python3_sitearch}/mpich/%{pypi_name}-%{version}-py%{python3_version}.egg-info
%endif
%endif

%changelog
* Tue Dec 05 2017 Antonio Trande <sagitterATfedoraproject.org> - 3.8.1-3
- Fix typo

* Sun Dec 03 2017 Antonio Trande <sagitterATfedoraproject.org> - 3.8.1-2
- Set arch suffix of MPI include directories

* Wed Nov 22 2017 Antonio Trande <sagitterATfedoraproject.org> - 3.8.1-1
- Update to 3.8.1

* Tue Oct 24 2017 Antonio Trande <sagitterATfedoraproject.org> - 3.8.0-2
- Move header files under /usr/include

* Sun Oct 22 2017 Antonio Trande <sagitterATfedoraproject.org> - 3.8.0-1
- Initial package
